#include "CheckerPosition.h"
#include "CheckerConsts.h"
#include <iostream>

CheckerPosition::CheckerPosition(int x, int y) : x(x), y(y) {}

CheckerPosition::CheckerPosition(std::string pos)
{
    x = pos[0] - 'A'; // 'A' = 0, 'B' = 2, 'C' = 3, ...
    y = pos[1] - '1'; // '1' = 0, '2' = 1, '3' = 2, ...
}

std::string CheckerPosition::to_string() const
{
    // Chess-like serialization
    return std::string(1, 'A' + x) + std::to_string(y + 1);
}

bool CheckerPosition::isValid() const
{
    // The position is valid if it's within the board
    return x >= 0 && x < BOARD_SIZE && y >= 0 && y < BOARD_SIZE;
}

std::string CheckerPosition::to_num_string() const
{
    // Coordinate-like serialization
    return "(" + std::to_string(x) + ", " + std::to_string(y) + ")";
}